import test from 'ava'
import Helpers from '../test_helper.js'

var car, ticket, owner

test.before(t => {
    car = new Helpers.Car(1)
    ticket  = new Helpers.Ticket(2, car)
    owner = new Helpers.Owner(3, ticket)
})

test.after('cleanup', t => {
})

test('Class name property should equal cars', t => {
    t.is('cars', car.process_class_name(car.constructor.name))
})

test('Test constructing url', t => {
    const url_with_id = car.construct_url()
    t.is('cars/1', url_with_id)
})

test('Test sub-resources 2 levels down', t => {
    const url_with_id = ticket.construct_url(2, ticket.parent)
    t.is('cars/1/tickets/2', url_with_id)
})

test('Test sub-resources 3 levels down', t => {
    const url_with_id = owner.construct_url(3, owner.parent)
    t.is('cars/1/tickets/2/owners/3', url_with_id)
})
