var config = require('./gulp/config.js');
var webpack = require('webpack');

module.exports = {
     name: 'node_config',
     target: 'node',
     debug: true,
     context: __dirname + '/' + config.js.src,
     entry: __dirname + '/' + config.js.main,
     devtool: 'source-map',
     output: {
         path: __dirname + config.js.dest,
         filename: config.project_name.toLowerCase() + '.min.js',
         library: config.project_name,
         libraryTarget: 'commonjs'
     },
     module: {
         loaders: [
            {
                test:  /\.json$/, loader: 'json-loader',
             }, {
                test: /\.js$/,
                exclude: /(node_modules|bower_components)/,
                loader: 'babel-loader'
             }
         ]
     },
     resolve: {
        extensions: ['', '.webpack.js', '.web.js', '.js']
    },
    node: {
        console: true,
        fs: 'empty',
        net: 'empty',
        tls: 'empty'
    },
    plugins: [
        new webpack.ProvidePlugin({
            $: "jquery",
            jQuery: "jquery"
        }),
        new webpack.optimize.OccurenceOrderPlugin(),
        new webpack.DefinePlugin({
            'process.env': {
                'NODE_ENV': JSON.stringify('production')
            }
        }),
        new webpack.optimize.UglifyJsPlugin({minimize: true})
    ]
 }
